#include <Application.h>
#include <Window.h>
#include <View.h>
#include <Button.h>
#include <GraphicsDefs.h>
#include <math.h>
#include <Alert.h>
#include <stdlib.h>
#include <stdio.h>
#include <Bitmap.h>
#include <TranslationUtils.h>
#include <OS.h>
#define BUTTON_HELP 'HLP'
#define BUTTON_CLEAR 'CLS'
BWindow *myWindow;
BView *myView;
BAlert *myAlert;
bool Feld[6][6];
bool Ziel[6][6];
int zanz = 0;
int hanz = 0;
int ZugX[9999];
int ZugY[9999];
int HilfeX[9999];
int HilfeY[9999];
int Level;
bool helpme;
bool dhelpme;
float SteinX, SteinY;
class klixApp: public BApplication{
	public:
		klixApp();
		virtual ~klixApp();
};

class klixWindow: public BWindow{
	public:
		klixWindow();
		virtual ~klixWindow();
		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage* message);
		virtual void FrameResized(float width, float height);
};

class klixView: public BView{
	public:
		klixView( BRect frame );
		virtual ~klixView();		
		virtual void Draw( BRect updateRect );
		virtual void MouseDown(BPoint point);
		virtual void MakeLevel(int level);
		virtual void Klick(int x, int y);
		virtual void Geschafft();
		virtual void zeichneFeld(BRect frame, bool Wert);
		BButton* help;
		BButton* loe;
		BBitmap* On;
		BBitmap* Off;
		BBitmap* hOn;
		BBitmap* hOff;
};

class klixAlert: public BAlert{
	public:
		klixAlert();
		virtual ~klixAlert();
};
		
int main( int argc, char **argv )
{
	BApplication *myApp = new klixApp;
	
	myApp->Run();
	
	delete myApp;
	
	return 0;
} 

klixApp::klixApp()
	: BApplication( "application/x-klixdraw" )
{
	SteinX = 50;
	SteinY = 50;
	myWindow = new klixWindow;
	myWindow->Show();
	srand(real_time_clock());
	return;
}

klixApp::~klixApp()
{
	return;
}

klixWindow::klixWindow()
	: BWindow( BRect( 100, 100, 100+SteinX*12+10,100+ SteinY*6+30),
										"klix",
										B_TITLED_WINDOW,
										B_NOT_ZOOMABLE)
{
	myView = new klixView( Bounds() );
		
	AddChild( myView );
	myView->Draw( Bounds());
	return;
}

klixWindow::~klixWindow()
{
	return;
}

void klixWindow::FrameResized(float width, float height)
{
			
	SteinX = (Bounds().Width()-10)/12;
	SteinY = (Bounds().Height()-30)/6;
	myView->Draw(Bounds());
}

bool klixWindow::QuitRequested()
{
	be_app->PostMessage( B_QUIT_REQUESTED );
	
	return true;
}

klixAlert::klixAlert()
	: BAlert("Level complete!","You did it! Are your ready for the next level?","Sure!")
{
	return;
}
klixAlert::~klixAlert()
{
	return;
}

klixView::klixView( BRect frame )
	: BView( frame, "klixView", B_FOLLOW_ALL_SIDES, B_WILL_DRAW )
{
	help = new BButton(BRect(70,0,130,20),"Help","Help",
					new BMessage(BUTTON_HELP));
	AddChild(help);
	loe = new BButton(BRect(0,0,60,20),"Clear","Clear",
					new BMessage(BUTTON_CLEAR));
	AddChild(loe);
	SetHighColor(0,0,0,0);
	SetLowColor(255,255,255,0);
	Level = 1;
	MakeLevel (Level);
	SetFont(be_bold_font);
	SetFontSize(24);
	On = BTranslationUtils::GetBitmapFile("On", NULL);
	Off = BTranslationUtils::GetBitmapFile("Off", NULL);
	hOn = BTranslationUtils::GetBitmapFile("HOn", NULL);
	hOff = BTranslationUtils::GetBitmapFile("HOff", NULL);
	return;
}

klixView::~klixView()
{
	return;
}

void klixView::Draw( BRect updateRect )
{
	SetFlags(Flags() | B_FULL_UPDATE_ON_RESIZE | B_WILL_DRAW);
	rgb_color bf;
	BRect frame = Bounds();    
	frame.top += 10;
	frame.left += 10;
	frame.bottom -= 10;
	frame.right -= 10;
	bf.red = 100;
	bf.green = 80;
	bf.blue =90;
	SetViewColor(B_TRANSPARENT_32_BIT);
	FillRect(BRect(0,0,Bounds().right,29));
	FillRect(BRect(SteinX*6,29,SteinX*6+10,Bounds().bottom));
	float x,y;
	helpme = false;
	for (y=0;y<6;y++) 
		{	
			for (x=0;x<6;x++) 
			{
				if (x == HilfeX[hanz] & y == HilfeY[hanz] & dhelpme )
				{
					helpme = true;
				}
				else
				{
					helpme = false;
				}
				zeichneFeld(BRect	(	
										x*SteinX,
										y*SteinY+30,
										x*SteinX+SteinX,
										y*SteinY+SteinY+30
									),
									Feld[int(x)][int(y)]);
				zeichneFeld(BRect	(
										x*SteinX+SteinX*6+10,
										y*SteinY+30,
										x*SteinX+SteinX*7+10,
										y*SteinY+SteinY+30
									),
									Ziel[int(x)][int(y)]);
			}
		}
	return;
}

void klixView::zeichneFeld( BRect frame, bool Wert)
{
	if (Wert) 
		{
			if (helpme)
			{
				DrawBitmapAsync(hOn,frame);
			}
			else
			{
				DrawBitmapAsync(On,frame);
			}
		}
	else
		{
			if (helpme)
			{
				DrawBitmapAsync(hOff,frame);
			}
			else
			{
				DrawBitmapAsync(Off,frame);
			}
		}
	return;
}

void klixWindow::MessageReceived(BMessage* message)
{
	int x,y;
	switch(message->what)
	{
		case BUTTON_HELP:
			hanz++;
			if (dhelpme)
			{
				dhelpme=false;
			}
			{
				dhelpme=true;
			}
			if (hanz >= Level) 
			{	
				dhelpme = false;
				hanz = 0;
			}
			myView->Draw(Bounds());
			break;
		case BUTTON_CLEAR:
			{
				for (x=0;x<6;x++)
					{
						for (y=0;y<6;y++)
							{
								Feld[x][y] = false;
							}
					}
				myWindow->SetTitle("klix");
				hanz = 0;
				dhelpme = false;
				myView->Draw(Bounds());
			}
			break;
		default:
			BWindow::MessageReceived(message);
	}
	return;
}

void klixView::MouseDown(BPoint point)
{
	int xcord;
	int ycord;
	int x2;
	int y2;
	xcord = int(point.x/SteinX);
	ycord = int((point.y-30)/SteinY);
	if (xcord < 6 & ycord < 6 & xcord >= 0 & ycord >= 0) 
		{
			dhelpme = false;
			ZugX[++zanz] = xcord;
			ZugY[zanz] = ycord;
			if (Feld[xcord][ycord])	Feld[xcord][ycord]= false;
			else Feld[xcord][ycord] = true;
			
			y2 = ycord;
			x2 = xcord+1;
			if (xcord == 5 ) x2 = 0;
			if (Feld[x2][y2])	Feld[x2][y2]= false;
			else 				Feld[x2][y2] = true;

			y2 = ycord;
			x2 = xcord-1;
			if (xcord == 0 ) x2 = 5;
			if (Feld[x2][y2])	Feld[x2][y2]= false;
			else 				Feld[x2][y2] = true;

			y2 = ycord+1;
			x2 = xcord;
			if (ycord == 5 ) y2 = 0;
			if (Feld[x2][y2])	Feld[x2][y2]= false;
			else 				Feld[x2][y2] = true;
			
			y2 = ycord-1;
			x2 = xcord;
			if (ycord == 0 ) y2 = 5;
			if (Feld[x2][y2])	Feld[x2][y2]= false;
			else Feld[x2][y2] = true;
						
		}
	bool alles;
	int x;
	int y;
	alles = true;
	for (x=0;x<6;x++)
		{
		for(y=0;y<6;y++){
			if (Ziel[x][y] == false){ if(Feld[x][y] == true ) alles = false;}
			if (Ziel[x][y] == true ){ if(Feld[x][y] == false) alles = false;}
			}
		}
	Draw(Bounds());
	if (alles == true) 
		{
		Geschafft();
		MakeLevel(++Level);
		Draw(Bounds());
		}
	return;
}
void klixView::MakeLevel (int level)
{
	int i;
	int x;
	int y;
	zanz = 0;
	hanz = 0;
	if (level > 15) level = 15;
	for(x=0;x<6;x++)
		{
			for(y=0;y<6;y++)
			{
				Ziel[x][y]=false;
				Feld[x][y]=false;
			}
		}

	for (i=0;i<level;i++){
		do {
		x = int(rand() % 5);
		y = int(rand() % 5);
		} while (Ziel[x][y] == true);
		Klick(x,y);	
		HilfeX[i] = x;
		HilfeY[i] = y;
	}
	return;	
}
void klixView::Klick(int x, int y)
{
		myWindow->SetTitle("klix");
			int x2;
			int y2;
			if (Ziel[x][y])	Ziel[x][y]= false;
			else Ziel[x][y] = true;
			y2 = y;
			x2 = x+1;
			if (x == 5 ) x2 = 0;
			if (Ziel[x2][y2])	Ziel[x2][y2]= false;
			else 				Ziel[x2][y2] = true;
			y2 = y;
			x2 = x-1;
			if (x == 0 ) x2 = 5;
			if (Ziel[x2][y2])	Ziel[x2][y2]= false;
			else 				Ziel[x2][y2] = true;
			y2 = y+1;
			x2 = x;
			if (y == 5 ) y2 = 0;
			if (Ziel[x2][y2])	Ziel[x2][y2]= false;
			else 				Ziel[x2][y2] = true;
			y2 = y-1;
			x2 = x;
			if (y == 0 ) y2 = 5;
			if (Ziel[x2][y2])	Ziel[x2][y2]= false;
			else 				Ziel[x2][y2] = true;

}
		void
klixView::Geschafft()
{
	myAlert = new klixAlert();
	myAlert->Go();
}
